////////////////////////////////////////////////////////////////////
//
//  Tutorial uso di MySql con driver ODBC della actual technologies
//
//  Created by Francesco Germinara 
// 
//  Freeware (c) 2005 SofTech di F.Germinara - www.germinara.it. 
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////

#import "panelCercaController.h"
#import "NSString+FGString.h" //Expand NSString class using Categories
#import "FGBseData.h"         //manage Data field

@implementation panelCercaController

- (void) dealloc {
	[rows release];
	[rowsDescr release];
	[rowsPers release];
	[rowsDescrPers release];	
	[super dealloc];
}

-(void) awakeFromNib{
   rows=[[NSMutableArray alloc]init];
   rowsDescr=[[NSMutableArray alloc]init];
   rowsPers=[[NSMutableArray alloc]init];
   rowsDescrPers=[[NSMutableArray alloc]init];
   [info setStringValue:@""];
   
   [elencoRisultati setTarget:self];
   [elencoRisultati setDoubleAction:@selector(loadSelectedData)]; //Double click
 
 }


- (IBAction)btnCercaPressed:(id)sender
{
    NSMutableString *strSearchQry;
	NSMutableString *strSearchQryRegali;
	NSMutableString *strQuery;
	int sts=0;

    NSString *aPersona=[[idPersona stringValue] TrimRight];
	NSString *aRegalo=[[idRegalo stringValue] TrimRight];
    NSString *aRicorrenza=[[idRicorrenza stringValue] TrimRight];

 //1: Non indico nulla nei campi persona,regalo e ricorrenza
 //   Errore
 if([aPersona isEqualToString:@""] &&
	[aRegalo isEqualToString:@""] &&
	[aRicorrenza isEqualToString:@""]){

    NSRunAlertPanel(@"ERROR",@"You must specify only one search field (person,gift or recurrence)!",@"OK",nil,nil);
    return;
 }

 [elencoRisultati setDataSource:nil]; 
 [rows removeAllObjects];
 [rowsDescr removeAllObjects];
 [rowsPers removeAllObjects];
 [rowsDescrPers removeAllObjects];

 
 //2: preparo la query per persona
  if(![aPersona isEqualToString:@""] &&
	[aRegalo isEqualToString:@""] &&
	[aRicorrenza isEqualToString:@""]){
    strSearchQry=[NSMutableString stringWithFormat:@"WHERE DESCR LIKE '%%%@%%' order by DESCR",aPersona];
	//Loop su persone
	sts=[theApp->pTabPersone OpenQuery:strSearchQry];
	while(sts==TRUE){
	//Nessun flag selezionato, cerco nello storico tutti i regali fatti per la persona indicata
      if(![flgAdattoSingle state]  && ![flgCosto state] && ![flgEta state] && ![flgIdealePer state]){
	   [info setStringValue:@"The search result was inherent to the gift already made"];
	   strSearchQryRegali=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA = '%@' order by ANNO,ID_REGALO",[[theApp->pTabPersone FieldInfo:@"ID_PERSONA"] GetValue] ];//Loop su storico
	   sts=[theApp->pTabStoricoRegali OpenQuery:strSearchQryRegali];
	   while(sts==TRUE){
	    NSString *idRegaloFound;
		idRegaloFound=[NSString stringWithString:[[theApp->pTabStoricoRegali FieldInfo:@"ID_REGALO"] GetValue]];
        [rows addObject:idRegaloFound];	 
	    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",idRegaloFound]; //Build the query 
        if([theApp->pTabRegali LoadDati:strQuery] == TRUE)
		 [rowsDescr addObject:[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight]];	
        else
		 [rowsDescr addObject:@"???"];	
		 
		 [rowsPers addObject:[[theApp->pTabPersone FieldInfo:@"ID_PERSONA"] GetValue]];	
	     [rowsDescrPers addObject:[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight]];
		
	    sts=[theApp->pTabStoricoRegali MoveNext];
	   }
	   [theApp->pTabStoricoRegali CloseQuery];	 
	  }else{ //Ci sono i flag da valutare, quindi cerco sui regali che soddisfano i flag attivati
	   [info setStringValue:@"The search result was inherent to the present that you can make"];
	   NSString *strClasola01,*strClasola02,*strClasola03,*strClasola04;
	   if([flgAdattoSingle state])
	    strClasola01=[NSMutableString stringWithFormat:@"ADATTO_SINGLE = '1' AND "];//Loop su regali
	   else	
	    strClasola01=[NSMutableString stringWithString:@""];
	   if([flgCosto state])
	    strClasola02=[NSMutableString stringWithFormat:@"COSTO <= %f AND ",[[[theApp->pTabPersone FieldInfo:@"BUDGET"] GetValue] doubleValue]];
	   else
	    strClasola02=[NSMutableString stringWithString:@""]; 
	   if([flgEta state]){
	    int eta=[[[theApp->pTabPersone FieldInfo:@"ETA"] GetValue] intValue];
		strClasola03=[NSMutableString stringWithFormat:@"(%d-ETA_DA)>=0 AND (ETA_A-%d)>=0 AND ",eta,eta];
	   }else
	    strClasola03=[NSMutableString stringWithString:@""];
	   if([flgIdealePer state]){
	    NSString *hobby=[[[theApp->pTabPersone FieldInfo:@"HOBBY"] GetValue] TrimRight];
		NSString *sport=[[[theApp->pTabPersone FieldInfo:@"SPORT"] GetValue] TrimRight];
		if(![hobby isEqualToString:@""] && ![sport isEqualToString:@""])
	     strClasola04=[NSMutableString stringWithFormat:@"(IDEALE_PER like '%%%@%%' OR IDEALE_PER like '%%%@%%') AND ",hobby,sport];
		if([hobby isEqualToString:@""] && ![sport isEqualToString:@""])
	     strClasola04=[NSMutableString stringWithFormat:@"IDEALE_PER like '%%%@%%' AND ",sport];
		if(![hobby isEqualToString:@""] && [sport isEqualToString:@""])
	     strClasola04=[NSMutableString stringWithFormat:@"IDEALE_PER like '%%%@%%' AND ",hobby];
		if([hobby isEqualToString:@""] && [sport isEqualToString:@""])
	     strClasola04=[NSMutableString stringWithFormat:@""]; 
	    }else
		 strClasola04=[NSMutableString stringWithString:@""];
		strSearchQryRegali=[NSMutableString stringWithFormat:@"WHERE %@%@%@%@",strClasola01,strClasola02,strClasola03,strClasola04];
		strSearchQryRegali=[NSMutableString stringWithString:[strSearchQryRegali substringWithRange:NSMakeRange(0,[strSearchQryRegali length]-4)]];
		[strSearchQryRegali appendString:@" order by DESCR"];
 
	    sts=[theApp->pTabRegali OpenQuery:strSearchQryRegali];
	    while(sts==TRUE){
	     NSString *idRegaloFound;
		 idRegaloFound=[NSString stringWithString:[[theApp->pTabRegali FieldInfo:@"ID_REGALO"] GetValue]];
         [rows addObject:idRegaloFound];	 
		 [rowsDescr addObject:[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight]];	
		 [rowsPers addObject:[[theApp->pTabPersone FieldInfo:@"ID_PERSONA"] GetValue]];	
		 [rowsDescrPers addObject:[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight]];
         sts=[theApp->pTabRegali MoveNext];
	    }
	    [theApp->pTabRegali CloseQuery];	 
	   }
	  
      sts=[theApp->pTabPersone MoveNext];
     }
    [theApp->pTabPersone CloseQuery];	
	
   }


   //3: preparo la query per ricorrenza
  if([aPersona isEqualToString:@""] &&
	[aRegalo isEqualToString:@""] &&
	![aRicorrenza isEqualToString:@""]){
  
	   [info setStringValue:@"The search result was inherent to the gift already made"];
	   strSearchQryRegali=[NSMutableString stringWithFormat:@"WHERE ID_TIPO_RICOR LIKE '%%%@%%' order by ANNO,ID_REGALO",aRicorrenza ];//Loop su storico
	   sts=[theApp->pTabStoricoRegali OpenQuery:strSearchQryRegali];
	   while(sts==TRUE){
	    NSString *idRegaloFound,*idPersonaFound;
		idRegaloFound=[NSString stringWithString:[[theApp->pTabStoricoRegali FieldInfo:@"ID_REGALO"] GetValue]];
        [rows addObject:idRegaloFound];	 
	    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",idRegaloFound]; //Build the query 
        if([theApp->pTabRegali LoadDati:strQuery] == TRUE)
		 [rowsDescr addObject:[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight]];	
        else
		 [rowsDescr addObject:@"???"];	
		 
		 idPersonaFound=[NSString stringWithString:[[theApp->pTabStoricoRegali FieldInfo:@"ID_PERSONA"] GetValue]];
		 [rowsPers addObject:idPersonaFound];	
         strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",idPersonaFound]; //Build the query 
         if([theApp->pTabPersone LoadDati:strQuery] == TRUE)
		  [rowsDescrPers addObject:[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight]];
		 else
		  [rowsDescrPers addObject:@"???"];
		
	    sts=[theApp->pTabStoricoRegali MoveNext];
	   }
	   [theApp->pTabStoricoRegali CloseQuery];	 
	   
  }
  
   //4: preparo la query per REGALI
  if([aPersona isEqualToString:@""] &&
	![aRegalo isEqualToString:@""] &&
	[aRicorrenza isEqualToString:@""]){
  
	   [info setStringValue:@"The search result was inherent to the gift already made"];
	   strSearchQryRegali=[NSMutableString stringWithFormat:@"WHERE ID_REGALO LIKE'%%%@%%'  order by ANNO,ID_REGALO",aRegalo ];//Loop su storico
	   sts=[theApp->pTabStoricoRegali OpenQuery:strSearchQryRegali];
	   while(sts==TRUE){
	    NSString *idRegaloFound,*idPersonaFound;
		idRegaloFound=[NSString stringWithString:[[theApp->pTabStoricoRegali FieldInfo:@"ID_REGALO"] GetValue]];
        [rows addObject:idRegaloFound];	 
	    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO = '%@' ",idRegaloFound]; //Build the query 
        if([theApp->pTabRegali LoadDati:strQuery] == TRUE)
		 [rowsDescr addObject:[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight]];	
        else
		 [rowsDescr addObject:@"???"];	
		 
		 idPersonaFound=[NSString stringWithString:[[theApp->pTabStoricoRegali FieldInfo:@"ID_PERSONA"] GetValue]];
		 [rowsPers addObject:idPersonaFound];	
         strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",idPersonaFound]; //Build the query 
         if([theApp->pTabPersone LoadDati:strQuery] == TRUE)
		  [rowsDescrPers addObject:[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight]];
		 else
		  [rowsDescrPers addObject:@"???"];
		
	    sts=[theApp->pTabStoricoRegali MoveNext];
	   }
	   [theApp->pTabStoricoRegali CloseQuery];	 
	   
  }
	
   [elencoRisultati setDataSource:self];

}

- (IBAction)btnChiudi:(id)sender
{
 [panelMovimenti->panelCerca orderOut:nil];
 [NSApp endSheet:panelMovimenti->panelCerca ];    //End the sheet loop
}


//Dato che questo oggetto  anche il datasource impostato per la tabella devo implementare questi metodi
- (int) numberOfRowsInTableView: (NSTableView*) tableView {
	int nRecord=0;
	nRecord=[rows count];
	return nRecord;
}

//Restituisce il dato della cella, per la colonna nota_com su tabella commesse indico se c'e' o meno una nota inserita
- (id) tableView: (NSTableView*) tableView objectValueForTableColumn: (NSTableColumn *) tableColumn row: (int) row {
 NSString *theCellValue;
 if([[tableColumn identifier] isEqualToString:@"ID_REGALO"])
  theCellValue=[rows objectAtIndex:row];
if([[tableColumn identifier] isEqualToString:@"DESCR_REGALO"])
  theCellValue=[rowsDescr objectAtIndex:row];
if([[tableColumn identifier] isEqualToString:@"ID_PERSONA"])
  theCellValue=[rowsPers objectAtIndex:row];
if([[tableColumn identifier] isEqualToString:@"DESCR_PERSONA"])
  theCellValue=[rowsDescrPers objectAtIndex:row];
  
 return(theCellValue);
}

//Double click action
-(void)loadSelectedData{
 int nSelectedRow=[elencoRisultati clickedRow];
 
   NSString *idPersonaSelected=[rowsPers objectAtIndex:nSelectedRow];
   NSString *idRegaloSelected=[rows objectAtIndex:nSelectedRow];
   
   [panelMovimenti->idPersona setStringValue:idPersonaSelected];
   [panelMovimenti->idRegalo setStringValue:idRegaloSelected];
   [panelMovimenti updateDescription];
   
   [self btnChiudi:self];
   
 }

@end
