////////////////////////////////////////////////////////////////////
//
//  FGBseField.m
//  
//
//  Created by Francesco Germinara on Mon Jun 07 2004.
// 
//  Copyright (c) 2004 SofTech di F.Germinara - www.germinara.it. All rights reserved.
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  6/8/2004 Cambiata routine di eliminazione spazi
//  Description:
//
////////////////////////////////////////////////////////////////////


#import "FGODBCFieldInfo.h"
#include <iODBC/sql.h>
#include <iODBC/sqlext.h>
#include <iODBC/sqlucode.h>
#import "NSString+FGString.h"

@implementation FGODBCFieldInfo

-(id)init{
 self=[super init];	
 strValue=[[NSString alloc]init];
 return self;
}

-(void)dealloc{
	[strValue release];
	[name release];
	[super dealloc];
}

//Set Object Values
-(void)SetValues:(NSString *) strName forType:(SWORD) nType  forPrecision:(UDWORD) nSQLPrecision forScale:(SWORD) nSQLScale  forNullability:(SWORD) nSQLNullability forCol:(int)nSQLcol{
	if(name!=nil)
	 [name release];
	name=[[NSString alloc] initWithString:strName];
	
	nSQLType=nType;   
	nPrecision=nSQLPrecision;   
	nScale=nSQLScale;       
	nNullability=nSQLNullability; 
	nCol=nSQLcol;
	
	//Calcolo la dimensione del campo in base al tipo di campo
	switch (nSQLType)
	 {
		case SQL_VARCHAR:
		case SQL_CHAR:
		case SQL_WCHAR:
		case SQL_WVARCHAR:
			nLenght = (short) nPrecision;
			break;
		case SQL_BIT:
			nLenght = 1;
			break;
		case SQL_TINYINT:
		case SQL_SMALLINT:
		case SQL_INTEGER:
		case SQL_BIGINT:
			nLenght = nPrecision + 1;	//Segno
			break;
		case SQL_DOUBLE:
		case SQL_DECIMAL:
		case SQL_NUMERIC:
		case SQL_FLOAT:
		case SQL_REAL:
			nLenght = nPrecision + 2;	//Segno e Virgola
			break;
		case SQL_DATE:
			nLenght = 10;
			break;
		case SQL_TIME:
			nLenght = 8;
			break;
		case SQL_TIMESTAMP:
			nLenght = 19;
			break;
		default:
			nLenght = nPrecision;     
	 }
}

//Return Field Name
-(NSString *) name{
 return name;
}

//Return Field Length
-(int) length{
 return nLenght;
}      

//Return Col
-(int) ColNum{
 return nCol;
}

//return Type
-(int) Type{
 return nSQLType;   
}

//Return precision
-(int) Precision{
	return nPrecision;   	
}

//Return Scale
-(int) Scale{
	return nScale;       	
}

//Return Nullability
-(int) Nullability{
	return nNullability; 	
}

//Set the new value
-(void) SetValue:(NSString *) strNewValore{
 if(strNewValore!=nil){
  [strValue release];
  strValue=[[NSString alloc] initWithString:strNewValore];
 }
}

//Get the value
-(NSString *) GetValue {
 NSString *strResult;	
 strResult=[strValue TrimRight];
/*	
 NSMutableString *strResult;	
 int length=0,end=0;
 length=[strValue length];
 end=length;
 while(end > 0 && isspace([strValue characterAtIndex:end-1])){
  end--;
 }
 strResult=[NSMutableString stringWithString:strValue];
 [strResult deleteCharactersInRange: NSMakeRange(end, length - end)];
 
 //Versione Originale...	
 //strResult=[strValue stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];	//TOLGO GLI SPAZI SUPERFUI...
*/
 return strResult;
}


//Get the value with the '' double for ' character
-(NSString *) GetValueForUpdateSQL {
	NSString *strResult;	
    char sqlTrasform[1024];
	NSString *strNewResult;
	
	strResult=[self GetValue];
	
	int nIndex=0;
	int nPos=0;
	int nlen=[strResult length];
	
	for(nIndex=0; nIndex<nlen; nIndex++,nPos++){
	 sqlTrasform[nPos]=[strResult characterAtIndex:nIndex];
	 if(sqlTrasform[nPos]=='\''){
	  nPos++;
	  sqlTrasform[nPos]='\'';
	 }
	}
	sqlTrasform[nPos]=0x00;
	
	strNewResult=[[[NSString alloc] initWithCString:sqlTrasform] autorelease];
	
	return strNewResult;
}

@end
