////////////////////////////////////////////////////////////////////
//
//  FGODBCResultSet.m
//  
//
//  Created by Francesco Germinara on Sat Jun 12 2004.
// 
//  Copyright (c) 2004 SofTech di F.Germinara - www.germinara.it. All rights reserved.
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////


#import "FGODBCResultSet.h"
#import "FGODBCRecord.h"
#import "NSString+FGString.h"

@implementation FGODBCResultSet

-(id)init{
 self=[super init];
 rows=[[NSMutableArray alloc]init];
 return self;	
}


//Init Object
-(id) init:(gstregaliapp*) mainObject SetIdentifier:(NSString *) identifier tableView:(NSTableView *)aTableViewObject{

 self=[super init];
	
  rows=[[NSMutableArray alloc]init];
  nLastNrows=0;    //remember last number of rows
 
  //Salvo informazioni per funzioni particolari
  strIdentifier=identifier;
  aTableObject=aTableViewObject;
  theApp=mainObject;
  
  return self;
}

-(void)dealloc{
	
 [rows removeAllObjects]; 
 [rows release];
 [strLastQuery release];
		
 [super dealloc];	
}

//Esecute Query
-(void)FillArray:(FGODBCRecord *)tabella SqlFilter:(NSString *) strFilter ProgressInd:(NSProgressIndicator *) pBar{
[rows removeAllObjects]; 	
//1: Conto quanti c'e' ne sono...
int nRecord=0;

if([strFilter isEqualToString:@""])
	nRecord=[tabella Count:strFilter]; 
else{
 NSScanner *scanner = [NSScanner alloc];
 NSString *countString=nil;

 [scanner initWithString:strFilter];
 [scanner scanUpToString:@"order by" intoString:&countString];

  nRecord=[tabella Count:countString]; 
 [scanner release];
}

if(pBar !=nil){
 [pBar setToolTip: [NSString stringWithFormat:@"N.Record elaborati: %d",nRecord]];
 [pBar startAnimation:self];
}	

//Query data ...
int sts=0;

sts=[tabella OpenQuery:strFilter];
while(sts==TRUE){
 FGODBCRecord *tmpRecord;	
 tmpRecord=[[FGODBCRecord alloc]initWithRecordData:tabella];

 [rows addObject:tmpRecord];
  
 [tmpRecord release];	

 sts=[tabella MoveNext];
}
[tabella CloseQuery];
	
 nLastNrows=[rows count];

 table=tabella;

[strLastQuery release];
strLastQuery=[[NSString alloc]initWithString:strFilter];


if(pBar !=nil){
 [pBar stopAnimation:self];
}	
}


//Return Single Field data row
-(NSString *) GetData:(NSString *)colID atRow:(int) row{
 NSString *strResult=nil;
 FGODBCRecord *tmpRecord=nil;
 tmpRecord=[rows objectAtIndex:row];
 
 if(tmpRecord != nil){
  //////////////////////// DATA SOURCE PERSONALITATION 
  if([strIdentifier isEqualToString:@"STORICOREGALI"]){ //datasource personalitation! 
   strResult=[NSString stringWithFormat:@"%@",[[tmpRecord FieldInfo:colID] GetValue] ];
 
   if([colID isEqualToString:@"ID_TIPO_RICOR"]){ //Load description instead of code !...
    NSMutableString *strQuery;
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_TIPO_RICOR='%@' ",strResult]; //Build the query 
    if([theApp->pTabRicorrenze LoadDati:strQuery] == TRUE)
     strResult=[NSString stringWithFormat:@"%@",[[[theApp->pTabRicorrenze FieldInfo:@"DESCR"] GetValue] TrimRight] ];
	 if([strResult isEqualToString:@"0000"])
	   strResult=[NSString stringWithString:@"Non importa"];
    }	
	
   if([colID isEqualToString:@"ID_PERSONA"]){ //Load description instead of code !...
    NSMutableString *strQuery;
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",strResult]; //Build the query 
    if([theApp->pTabPersone LoadDati:strQuery] == TRUE)
     strResult=[NSString stringWithFormat:@"%@",[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight] ];
    }	
	
   if([colID isEqualToString:@"ID_REGALO"]){ //Load description instead of code !...
    NSMutableString *strQuery;
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",strResult]; //Build the query 
    if([theApp->pTabRegali LoadDati:strQuery] == TRUE)
     strResult=[NSString stringWithFormat:@"%@",[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight] ];
    }	
	
   
 }else  //////////////////////// END DATA SOURCE PERSONALITATION 
  strResult=[NSString stringWithFormat:@"%@",[[tmpRecord FieldInfo:colID] GetValue] ];	
	
 //////////////////////// COLUMN DATA SOURCE PERSONALITATION FOR DISPLAY DATE WITH SEPARATOR
 if([colID isEqualToString:@"NATOIL"]){ //Date...
	 NSString *strAA=[strResult substringWithRange:NSMakeRange(0,4)];
	 NSString *strMM=[strResult substringWithRange:NSMakeRange(4,2)];
	 NSString *strGG=[strResult substringWithRange:NSMakeRange(6,2)];
	 NSString * strData;
	 strData=[NSString stringWithFormat:@"%@/%@/%@",strGG,strMM,strAA];
     return strData;
  }

 }
	
 return strResult;		
}

//Return numer of rows
-(int)count{
 return [rows count];
} 

//Redo initial query
-(void)ReQuery:(NSProgressIndicator *) pBar{
 [self FillArray:table SqlFilter:strLastQuery ProgressInd:pBar];
} 

//Free all data contents
-(void)RemoveAllData{
 [rows  removeAllObjects];
}

//Get Single Row data
-(FGODBCRecord *)GetSingleRow:(int)row{
 FGODBCRecord *tmpRecord;
 tmpRecord=[rows objectAtIndex:row]; 	
 return tmpRecord;
}

//Set Single Row data
-(void)SetSingleRow:(FGODBCRecord *) rowData atRow:(int)row{
 [rows replaceObjectAtIndex:row withObject:rowData];
}

//Dato che questo oggetto  anche il datasource impostato per la tabella devo implementare questi metodi
- (int) numberOfRowsInTableView: (NSTableView*) tableView {
	int nRecord=0;
	nRecord=[rows count];
	return nRecord;
}

//Restituisce il dato della cella, per la colonna nota_com su tabella commesse indico se c'e' o meno una nota inserita
- (id) tableView: (NSTableView*) tableView objectValueForTableColumn: (NSTableColumn *) tableColumn row: (int) row {
 NSString *theCellValue=[self  GetData:[tableColumn identifier] atRow:row];
 return(theCellValue);
}

//Add Row data
-(void)AddRow:(FGODBCRecord *) rowData{
 [rows addObject:rowData];
}

@end
